
#include "MyCT.h"

extern "C"
{
	#include "../Modules/image.h"
	#include "../Encoders/genmodel.h"
	#include "../Encoders/gencoder.h"
	#include "../Modules/image_old.h"

	#include "../Modules/interfc.h"
	#include "../Modules/memctrl.h"
	#include "../Modules/color.h"
	#include "../Encoders/qmodel.h"
	#include "../Encoders/qmcoder.h"
	#include "ct.h"
}


#include <time.h>
#include "../Quantization/HistoData.h"

#define  EncodePixel(pGenCoder, pGenModel, pixel, context)         \
         (pGenCoder)->Encode ((pGenCoder)->Coder, (pixel),       \
         (BYTE*)((pGenModel)->Model) + context*(pGenModel)->Size)

#define  DecodePixel(pGenCoder, pGenModel, pixel, context)         \
         (pixel) = (pGenCoder)->Decode ((pGenCoder)->Coder,      \
         (BYTE*)((pGenModel)->Model) + context*(pGenModel)->Size)

#define VECTORELEMENT1 char

int Counter;
int NColors;

void PrintInfo(void)
{
	//HZ
}
/*
void GetMemoryUsage( MULTITREE *CT, ULONG &Total, ULONG &Useless, ULONG NColors)
{
	Total += sizeof(int) + sizeof(ULONG) + sizeof(ULONG) + sizeof(MULTITREE**) + sizeof(ULONG*);
	//child pos + context + total + chldren + pixels
	if(CT->Pixels)
	{
		Total += sizeof(ULONG)*NColors;
		for(int i=0; i<NColors; i++)
			if(!CT->Pixels[i])
				Useless+=sizeof(ULONG);
	}

	if(CT->Children)
	{
		Total += sizeof(MULTITREE*)*NColors;
		for(int i=0; i<NColors; i++)
			if(!CT->Children[i])
				Useless+=sizeof(MULTITREE*);
			else
				GetMemoryUsage(CT->Children[i], Total, Useless, NColors);
	}
}
*/
long GetContextIndexCT(MULTITREE *CT, BYTE *Data, int x, QSMODEL* model)
{
	MULTITREE *CCT;
	BYTE p;
	ChildListItem *pCurItem=0;

	CCT = CT;

	while(CCT->pChildren != NULL)
	{
		
		if(x - CCT->ChildPosition>=0)
			p = Data[x - CCT->ChildPosition];
		else
			p = 0;

//		if(CCT->Children[p] == NULL)
//			printf("\nIDIOT!!!");

		pCurItem = FindChildItem(CCT,p);

		if(pCurItem/*CCT->Children[p]*/!=NULL)
		{
	//		if(CCT->Context != -1)
	//			qsupdate(model + CCT->Context, Data[x]);


			//CCT = CCT->Children[p];
			CCT = pCurItem->pNode;
		}
		else
			break;
	}

	return CCT->Context;
}

long GetContextIndexCTImage(MULTITREE *CT, IMAGE *GrayImage, int* lut, int x, int y, int *ChildsLut, int StartX, int StartY, int EndX, int EndY)
{
	MULTITREE *CCT;
	int p;
	int refx, refy;
	ChildListItem *pCurItem=0;

#ifdef TEMPLATE_2D
    int  tJBIGX[31] = {30,-1,0,-1,+1,-2,0,-2,+2,-1,+1,-2,+2,-3,0,-3,+3,-1,+1,-3,+3,-2,+2,-4, 0,-4,+4,-1,+1,-3,+3 };
    int  tJBIGY[31] = {30,0,-1,-1,-1,0,-2,-1,-1,-2,-2,-2,-2,0,-3,-1,-1,-3,-3,-2,-2,-3,-3, 0,-4,-1,-1,-4,-4,-3,-3 };

//	int  tJBIGX[31] = {30,-1,  0, -2, +1, -1, 0, -3, +2, -2, +1, -1, 0, -4, +3, -3, +2, -2, +1, -1, 0, -5, +4, -4, +3, -3, +2, -2, +1, -1, 0,};
//    int  tJBIGY[31] = {30, 0, -1,  0, -1, -1, -2, 0, -1, -1, -2, -2, -3, 0, -1, -1, -2, -2, -3, -3, -4, 0, -1, -1, -2, -2, -3, -3, -4, -4, -5};


#else 
    int  tJBIGX[31] = {30,-1,-2,-3,-4,-5, -6,-7,-8,-9,-10,-11,-12,-13, -14,-15, -16,-17, -18,-19,-20,-21,-22, -23, -24,-25,-26,-27,-28,-29,-30};
    int  tJBIGY[31] = {30,0,0,0,0,0,00,00,00,00,00,00,00,0,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00 };
#endif


	CCT = CT;

	while(CCT->pChildren != NULL)
	{
		refx = x + tJBIGX[CCT->ChildPosition];
		refy = y + tJBIGY[CCT->ChildPosition];
		
		if((refx>=StartX && refx <= EndX) && (refy>=StartY && refy <= EndY))
			p = lut[GetGrayPixel(GrayImage,refx,refy)];
		else
			p = 0;


		if(ChildsLut)
			p = ChildsLut[p];

		pCurItem = FindChildItem(CCT,p);

		if(pCurItem/*CCT->Children[p]*/!=NULL)
			CCT = pCurItem->pNode;//CCT = CCT->Children[p];
		else
			break;
	}

	return CCT->Context;
}



long GetContextIndexCTImageFT(MULTITREE *CT, IMAGE *GrayImage, int* lut, int x, int y,
							  int *ChildsLut, TEMPLATEFT *FT, int FreeTreeDepth, int x_size, int y_size)
{
	MULTITREE *CCT;
	TEMPLATEFT *FFT;
	int p;
	int refx, refy;
	char *Template;
	int TemplateSize;

	ChildListItem *pCurItem=0;

#ifdef TEMPLATE_2D
    int  tJBIGX[31] = {30,-1,0,-1,+1,-2,0,-2,+2,-1,+1,-2,+2,-3,0,-3,+3,-1,+1,-3,+3,-2,+2,-4, 0,-4,+4,-1,+1,-3,+3 };
    int  tJBIGY[31] = {30,0,-1,-1,-1,0,-2,-1,-1,-2,-2,-2,-2,0,-3,-1,-1,-3,-3,-2,-2,-3,-3, 0,-4,-1,-1,-4,-4,-3,-3 };

//	int  tJBIGX[31] = {30,-1,  0, -2, +1, -1, 0, -3, +2, -2, +1, -1, 0, -4, +3, -3, +2, -2, +1, -1, 0, -5, +4, -4, +3, -3, +2, -2, +1, -1, 0,};
//    int  tJBIGY[31] = {30, 0, -1,  0, -1, -1, -2, 0, -1, -1, -2, -2, -3, 0, -1, -1, -2, -2, -3, -3, -4, 0, -1, -1, -2, -2, -3, -3, -4, -4, -5};

#else 
    int  tJBIGX[31] = {30,-1,-2,-3,-4,-5, -6,-7,-8,-9,-10,-11,-12,-13, -14,-15, -16,-17, -18,-19,-20,-21,-22, -23, -24,-25,-26,-27,-28,-29,-30};
    int  tJBIGY[31] = {30,0,0,0,0,0,00,00,00,00,00,00,00,0,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00 };
#endif


	CCT = CT;
	FFT = FT;
	
	TemplateSize = (x_size*y_size) + (x_size+1)*(y_size-1);
	Template = (char*)malloc(TemplateSize);
	memset(Template, 0, TemplateSize);


	char j_used[31];
	memset(j_used, 0, 31);


	while(CCT->pChildren != NULL)
	{
		if(CCT->ChildPosition <= FreeTreeDepth)
		{
			refx = x + FFT->ShiftX;
			refy = y + FFT->ShiftY;

			int index = Shifts2Index(x_size, y_size, FFT->ShiftX, FFT->ShiftY);
			Template[index] = 1;
		}
		else
		{
			int ShiftX, ShiftY;
			GetClosestUnusedTemplatePosition(Template, &ShiftX, &ShiftY, x_size, y_size, CCT->ChildPosition, j_used);
			
			refx = x + ShiftX;
			refy = y + ShiftY;
		}

		if(((unsigned long)refx>0 && (unsigned long)refx <= GrayImage->ImageSizeX) && ((unsigned long)refy>0 && (unsigned long)refy <= GrayImage->ImageSizeY))
			p = lut[GetGrayPixel(GrayImage,refx,refy)];
		else
			p = 0;


		if(ChildsLut)
			p = ChildsLut[p];

		pCurItem = FindChildItem(CCT,p);

		if(pCurItem/*CCT->Children[p]*/!=NULL)
		{
			CCT = pCurItem->pNode;//CCT = CCT->Children[p];
			if(CCT->ChildPosition <= FreeTreeDepth && FFT->Children)
				if(FFT->Children[p])
					FFT = FFT->Children[p];
		}
		else
			break;
	}

	free(Template);
	
	return CCT->Context;
}


/*
void ZeroTree(MULTITREE *CT)
{
	CT->Total = 0;

	for(int i = 0; i < NColors; i++)
		CT->Pixels[i] = 0;

	if(CT->Children)
	for(i=0; i<NColors;i++)
		if(CT->Children[i])
			ZeroTree(CT->Children[i]);
}
*/
/*
void GetTreeEntropy(MULTITREE *CT, double *Entropy)
{
	int i,j;
	
	if(CT->Context != -1)
	{
		if(CT->Children!=NULL)
		{
			for(i=0;i<NColors;i++)
			{
				if(CT->Children[i])
				{
					CT->Total -= CT->Children[i]->Total;
					for(j = 0; j<NColors;j++)
					{
						CT->Pixels[j] -= CT->Children[i]->Pixels[j];
					}
				}
			}
			
			if(CT->Total)
			(*Entropy) += CT->Total*GetCodeSizeSemi(CT);
		}
		else
		{
			(*Entropy) += CT->Total*GetCodeSizeSemi(CT);
		}
	}


	for(i=0;i<NColors;i++)
	{
		if(CT->Children!=NULL)
		if(CT->Children[i]!=NULL)
			GetTreeEntropy(CT->Children[i], Entropy);
	}
}
*/

YESNO InitQSModelNew(GENMODEL *pGModel, ULONG NModels, int NSymbols, int Process, int ModellingType, UINT16 *Init)
{
  ULONG i;
  int k, end, initval;
  QSMODEL *m;
  ULONG ci =0;

   
  pGModel->NModels       = NModels;
  pGModel->ModellingType = (MODELLINGTYPE) ModellingType;
  pGModel->NSymbols      = NSymbols;
  pGModel->Process       = (PROCESSTYPE) Process;

  pGModel->Model = allocate(sizeof(QSMODEL)*NModels);

  if (pGModel->Model==NULL) return NO;

  m = (QSMODEL*) pGModel->Model;
  for(i=0;i<NModels;i++) 
    initqsmodel(m+i, NSymbols, BITSINCNT, (1<<(BITSINCNT-1))-10, pGModel->Process);

  for(i=0;i<NModels;i++)
  {
//     if (ModellingType != ADAPTIVE)
  //  {
 //     (m+i)->init = allocate(sizeof(UINT16)*NSymbols);
 //     memset(m+i, 0, sizeof(UINT16)*NSymbols);
 //   }
 //   else 
      (m+i)->init = NULL;
  }

  
  if(ModellingType != ADAPTIVE)
  {
	  for(i=0; i<NModels; i++)
	  {      
		  
//		  if(i==128)
//			  i = i;
		  
		  (m+i)->rescale = (m+i)->n>>4 | 2;
		  (m+i)->nextleft = 0;
//		if ((m + i)->init != NULL)
  //      {

			double total = 0;
			ULONG sum = 0;
			int maxI = 0;
			ULONG maxF = 0;

			for(k = 0;k<(m + i)->n;k++)
				total += Init[i*NColors + k];

           for(k=0; k<(m + i)->n-1; k++) 
		   {
				(m + i)->newf[k] = (m+i)->cf[(m + i)->n]*Init[i*NColors + k]/(unsigned short)total;
				if(Init[i*NColors + k] && !(m + i)->newf[k]) (m + i)->newf[k] = 1;


				if(maxF<(m + i)->newf[k])
				{
					maxI = k;
					maxF = (m + i)->newf[k];
				}
				sum += (m + i)->newf[k];
		   }


			(m + i)->newf[(m + i)->n-1] = (m+i)->cf[(m + i)->n] - (unsigned short)sum;

			if(!(m + i)->newf[(m + i)->n-1] && Init[i*NColors + k])
			{
				(m + i)->newf[(m + i)->n-1] = 1;
				(m + i)->newf[maxI] -= 1;
			}


		   
//           break;
    //    }
		dorescale(m+i);
	  }
  }
  else
  {

	  for(i=0; i<NModels; i++) // i run for number of models
	  {
		m->rescale = m->n>>4 | 2;
		m->nextleft = 0;
		initval = m->cf[m->n] / m->n;
		end = m->cf[m->n] % m->n;
		for (k=0; k<end; k++) m->newf[k] = initval+1;
		for (; k<m->n; k++) m->newf[k] = initval;
		dorescale(m);
		m++;
	  }
  }
 
  return YES;
}


int LoadImageData(BYTE **Data, int *DataLength, int *ElemNum, double *Delta)
{
	IMAGE_OLD im;
	FILE *f;
	int i,j;

	int abc[256];
	int abcL;

	for(i=0;i<256;i++)
		abc[i] = -1;

	abcL = 0;

	f = fopen("lena.pgm", "rb");
	
	InitializeImage(f,&im,INPUT,WHOLEIMAGE_OLD,1); 
	ReadWholeImage(&im);
	


	for(i=1;i<=im.ImageSizeY;i++)
	{
		for(j=1;j<=im.ImageSizeX;j++)
		{
			int pixel = GetImageGray(&im,j,i);

			if(abc[pixel] == -1)
			{
				abc[pixel] = abcL;
				abcL++;
			}
		}
	}

	RewindImage(&im);


	(*ElemNum) = abcL;
	(*Delta) = 1/(double)abcL;
	(*DataLength) = im.ImageSizeY*im.ImageSizeX;
	(*Data) = (BYTE*)malloc((*DataLength)*sizeof(BYTE));

	int ci = 0;

	for(i=1;i<=im.ImageSizeY;i++)
	{
		for(j=1;j<=im.ImageSizeX;j++)
		{
			int pixel = GetImageGray(&im,j,i);
			(*Data)[ci++] = abc[pixel];
			
		}
	}

	FreeImage(&im);
	fclose(f);

	return 1;
}

void LutInit(IMAGE* GrayImage, int *ElemNum, double *Delta, int *lut, int *backlut)
{
	unsigned int i,j;
	int ci = 0;

	int count[256];

//	int backlut[256];
	

	memset(count, 0, 256);

	for(i = 1; i <= GrayImage->ImageSizeY; i++)
	{
		for(j = 1; j <= GrayImage->ImageSizeX; j++)
		{
			int pixel = GetGrayPixel(GrayImage,j,i);
		
			if(lut[pixel] == -1)
			{
				lut[pixel] = ci++;
				backlut[lut[pixel]] = pixel;
			}

			count[lut[pixel]]++;
		}
	}


/*	for(i = 0; i<ci-1; i++)
	{
		for(j=i+1;j<ci;j++)
		{
			if(count[i]>count[j])
			{
				int pixel1, pixel2;
				int temp;

				pixel1 = backlut[i];
				pixel2 = backlut[j];

				temp = count[i];
				count[i] = count[j];
				count[j] = temp;

				backlut[i] = pixel2;
				backlut[j] = pixel1;

				lut[pixel1] = j;
				lut[pixel2] = i;
			}
		}
	}*/

	(*ElemNum) = ci;
	(*Delta)   = (double)1/(double)ci;

	ImageRewind(GrayImage);
} 



long IndependentContextEncodingImage(FLOW* f, MULTITREE* Root, int ContextNumber, IMAGE* GrayImage, int* lut, int BitLength)
{
	return 100;
}

long BinDataEncoder(IMAGE* GrayImage, int* lut, int BitLength, MULTITREE* Root, FLOW *f, GENCODER *Coder, GENMODEL *Model, int* ChildsLut, 
					TEMPLATEFT *RootFT, int FreeTreeDepth, int x_size, int y_size, int index)
{
	long result = 0;
	
	int x,y,k;

	int StartX, StartY, EndX, EndY;
	
	ULONG LocalNStates = ((1<<(BitLength)) - 1);
	Model->ReInitModel(Model);
    Coder->InitCoder(Coder->Coder, f, 1);

	GetClusterBounds(GrayImage, index, &StartX, &StartY, &EndX, &EndY);


	for(y = StartY; y<= EndY;y++)
	{
		for(x = StartX; x<=EndX;x++)
		{
			int code = GetGrayPixel(GrayImage,x,y);
			long GlobalIndex;
			
			if(FREE_TREE == 1)
				GlobalIndex = GetContextIndexCTImageFT(Root, GrayImage, lut,x,y,ChildsLut, RootFT, FreeTreeDepth, x_size, y_size);
			else
				GlobalIndex = GetContextIndexCTImage(Root,GrayImage,lut,x,y, ChildsLut, StartX, StartY, EndX, EndY); 

			if(GlobalIndex < 0)
				GlobalIndex = GlobalIndex;


			code = lut[code];

			GlobalIndex = GlobalIndex*LocalNStates;

			int LocalModelIndex = 0;

			for(k = BitLength; k>0;k--)
			{
				int bit = (code>>(k-1))&0x01;
				int offset = GlobalIndex + LocalModelIndex;
				EncodePixel(Coder, Model, bit, offset);
				LocalModelIndex = LocalModelIndex + 1;
				
				if(bit)
					LocalModelIndex += ((1<<(k-1))-1);
			}
		}
	}	

	ImageRewind(GrayImage);

	result += Coder->Flush(Coder->Coder);

	return result;
}


long BinDataDecoder(IMAGE* GrayImage, int* lut, int* backlut, int BitLength, MULTITREE* Root, FLOW *f, GENCODER *Coder, GENMODEL *Model, int* ChildsLut, TEMPLATEFT *FT, int FreeTreeDepth, int x_size, int y_size)
{
	long result = 0;
	
	unsigned int x,y,k;
	
	ULONG LocalNStates = ((1<<(BitLength)) - 1);
	Model->ReInitModel(Model);
    Coder->InitCoder(Coder->Coder, f, 1);

	
	for(y = 1; y<= GrayImage->ImageSizeY;y++)
	{
		for(x = 1; x<= GrayImage->ImageSizeX;x++)
		{
			
			long GlobalIndex;
			if(FT)
				GlobalIndex = GetContextIndexCTImageFT(Root,GrayImage,lut,x,y, ChildsLut, FT, FreeTreeDepth, x_size, y_size);
			else
				GlobalIndex = GetContextIndexCTImage(Root,GrayImage,lut,x,y, ChildsLut, 1,1,GrayImage->ImageSizeX,GrayImage->ImageSizeY); 



			GlobalIndex = GlobalIndex*LocalNStates;

			int LocalModelIndex = 0;
			int code = 0;

			for(k = BitLength; k>0;k--)
			{
				int bit;
				int offset = GlobalIndex + LocalModelIndex;
				DecodePixel(Coder, Model, bit, offset);
				code = (code<<1) + bit;
				LocalModelIndex = LocalModelIndex + 1;
				
				if(bit)
					LocalModelIndex += ((1<<(k-1))-1);
			}
			
			code = backlut[code];
			
			PutGrayPixel(GrayImage,x,y, code);
		}
	}	


	result += Coder->Flush(Coder->Coder);

	return result;
}


double MyDecodeCTImage(char *FileName, char *OutputFileName, int glob_index, int loc_index)
{
	double result = 0;

	FLOW DiskFlow;
	FILE *file;
	IMAGE GrayImage;

	int *lut;
	int *backlut;
	int ElemNum;
	int index = loc_index;

	ULONG SizeX, SizeY;

	ULONG x,y;
	int i;

	int ChildsLut[256];


	ULONG GlobalOffset = 0;


	for(x=0;x<256;x++)
		ChildsLut[x] = x;

	file = fopen(FileName,"rb");
	InitFlow(&DiskFlow,F_FILE,file,1);


	for(i = 0;i<glob_index+1;i++)
		GlobalOffset = DiskFlow.InputValue(&DiskFlow, 32);

	DiskFlow.SeekFlow(&DiskFlow, GlobalOffset, SEEK_SET);


	
	ElemNum = DiskFlow.InputByte(&DiskFlow) + 1;

	lut = (int*)malloc(sizeof(int)*256);
	for(i = 0; i < ElemNum; i++)
		lut[i] = -1;

	backlut = (int*)malloc(sizeof(int)*ElemNum);


	for(i = 0; i < ElemNum; i++)
	{
		backlut[i] = DiskFlow.InputByte(&DiskFlow);
		lut[backlut[i]] = i;
	}


	SizeX = DiskFlow.InputValue(&DiskFlow,16);
	SizeY = DiskFlow.InputValue(&DiskFlow,16);


	int RN = DiskFlow.InputByte(&DiskFlow);

	if(RN)
	{
		for(i = 0;i<ElemNum;i++)
			ChildsLut[i] = DiskFlow.InputByte(&DiskFlow);
	}


	//FRREE TRREE
	int isFT;
	int FreeTreeDepth;
	int x_size, y_size;
	int TemplateSize;
	int BitLengthFT;

	TEMPLATEFT *RootFT;


	isFT = DiskFlow.InputByte(&DiskFlow);

	if(isFT)
	{
		FreeTreeDepth = DiskFlow.InputByte(&DiskFlow);
		x_size = DiskFlow.InputByte(&DiskFlow);
		y_size = DiskFlow.InputByte(&DiskFlow);
		TemplateSize = x_size*y_size + (x_size+1)*(y_size-1);
		BitLengthFT = (int)ceil(log(TemplateSize-1)/LOG2);
	}


	
	DiskFlow.FlushInput(&DiskFlow);

	SetImageSize(&GrayImage, SizeX, SizeY);
	ImageInit("a", &GrayImage, OUTPUT, 1, WHOLEIMAGE, GRAYMODE, MEMORY, 1);

	MULTITREE *Root;

	Root = NewTreeNode();

	int counter = 0;

	SetNColors(ElemNum);


	if(isFT)
		SetFreeTreeParam(FreeTreeDepth, BitLengthFT);

	if(RN)
		SetQuantizedNChilds(RN,ChildsLut);

	Root->ChildPosition = 1;
	SetRoot(Root);
	ReadMT(Root, &DiskFlow, &counter);
	
	int ContextNumber = 0;
	SetNumbers(Root, &ContextNumber);
//	PrintTree(Root);

	if(isFT)
	{
		RootFT = NewFTNode();

//		OpenLogFile();
		ReadFT(RootFT, Root, &DiskFlow, BitLengthFT, x_size, y_size);
//		CloseLogFile();
	}
	else
		RootFT = NULL;



	DiskFlow.FlushInput(&DiskFlow);

//	PrintTree(Root);
	
	int RC = DiskFlow.InputByte(&DiskFlow);
	int BitLength = (int)ceil(log(ElemNum)/LOG2);


	ULONG CurrentFilePosition = DiskFlow.TellFlow(&DiskFlow);
	ULONG offset;
	
	for(i = 0;i<index+1;i++)
		offset = DiskFlow.InputValue(&DiskFlow, 32);

	DiskFlow.SeekFlow(&DiskFlow, offset, SEEK_SET);

	if(RC) //range coder
	{
		RCENC rc;
		GENMODEL gm;
		
		RCInitDecoder(&rc,&DiskFlow,BitLength);
		InitQSModel(&gm, ContextNumber, ElemNum, DECODING, ADAPTIVE);

		for(y = 1; y<= GrayImage.ImageSizeY; y++)
		{
			for(x = 1; x<=GrayImage.ImageSizeX; x++)
			{
				long index;
				
				if(isFT)
				{
					index = GetContextIndexCTImageFT(Root, &GrayImage, lut, x, y, ChildsLut, RootFT, FreeTreeDepth, x_size, y_size);
				}
				else
					index = GetContextIndexCTImage(Root,&GrayImage,lut,x,y, ChildsLut, 1, 1, GrayImage.ImageSizeX, GrayImage.ImageSizeY);
				
				
				int code = RCDecode(&rc, (QSMODEL*)(gm.Model) + index);

				code = backlut[code];

				PutGrayPixel(&GrayImage, x,y,code);
			}
		}

	
		result = RCFlushDecoder(&rc);
		DoneQSModel(&gm);
	}
	else //MQ coder for non-binary information
	{
		GENMODEL Model;
		GENCODER Coder;
		int NSymbols = 2;

		GENPrepareModel(&Model, 0);
		GENPrepareCoder(&Coder, 0, DECODING);
		Model.InitModel(&Model, ContextNumber*((1<<BitLength) -1), NSymbols, DECODING, ADAPTIVE);
		
		result = BinDataDecoder(&GrayImage, lut, backlut, BitLength, Root, &DiskFlow, &Coder, &Model, ChildsLut, RootFT, FreeTreeDepth, x_size, y_size);
		
		GENDoneCoder(&Coder);
		Model.DoneModel(&Model);
	}


	DeallocateTree(Root);
	
	
	if(isFT)
		DeallocateFT(RootFT);
	
	DumpImage(&GrayImage, OutputFileName);
	free(lut);
	free(backlut);
	DiskFlow.FlushInput(&DiskFlow);
	ImageDone(&GrayImage);
	fclose(file);
	
	return result;
}


double InitChildsLut1(IMAGE *GrayImage, int *lut, int ElemNum, int* ChildsLut, int RN)
{
	
unsigned int x,y;
int i,j;
	int pixel;

	double *stat;
	double total = 0;

	if(RN>=ElemNum)
		return 1;

	stat = new double[ElemNum];

	memset(stat, 0, sizeof(double)*ElemNum);

	for(i=0;i<ElemNum;i++)  ChildsLut[i] = i;

	for(y = 1; y <= GrayImage->ImageSizeY; y++)
	{
		for(x = 1; x <= GrayImage->ImageSizeX; x++)
		{
			pixel = GetGrayPixel(GrayImage,x,y);
			pixel = lut[pixel];
			stat[pixel] = stat[pixel] + 1;

			total++;
		}
	}


//	for(i=0;i<ElemNum;i++)
//		stat[i] = total - stat[i];

	/*QUANTIZATION*/

	CHistoData      *pHData = NULL;
	pHData = new CHistoData(stat, ElemNum);

	double E2 = 0;
	pHData->DP_MSE(RN,2,2,&E2);

	int shift= (RN-1)*RN;
	int cur_index = 0;

	for(i=0;i<RN;i++)
	{
		double Thr_1 = pHData->m_pClustersThr[shift + (cur_index++)];
		double Thr_2 = pHData->m_pClustersThr[shift + (cur_index++)];

		for(j=0;j<ElemNum;j++)
		{
			double val = stat[j];
//			double val = total - stat[j];

			if(val>=Thr_1 && val<=Thr_2)
				ChildsLut[j] = i;
		}
	}

	pHData->FreeMemory();
	delete pHData;

	/*End of quantization*/

	delete [] stat;
	ImageRewind(GrayImage);
	return E2;
}


double InitChildsLut2(IMAGE *GrayImage, int *lut, int ElemNum, int* ChildsLut, int RN)
{
	
	unsigned int x,y;
	int i,j;
	int pixel;

	double *stat;
	double total = 0;

	if(RN>=ElemNum)
		return 1;

	stat = new double[GrayImage->ImageSizeX*GrayImage->ImageSizeY];

	memset(stat, 0, sizeof(double)*GrayImage->ImageSizeX*GrayImage->ImageSizeY);

	for(i=0;i<ElemNum;i++)  ChildsLut[i] = i;
	

	int ci = 0;

	for(y = 1; y <= GrayImage->ImageSizeY; y++)
	{
		for(x = 1; x <= GrayImage->ImageSizeX; x++)
		{
			pixel = GetGrayPixel(GrayImage,x,y);
			stat[ci++] = pixel;
		}
	}


	/*QUANTIZATION*/

	CHistoData      *pHData = NULL;
	pHData = new CHistoData(stat, GrayImage->ImageSizeX*GrayImage->ImageSizeY);

	double E2 = 0;
	pHData->DP_MSE(RN,2,2,&E2);

	int shift= (RN-1)*RN;
	int cur_index = 0;

	for(i=0;i<RN;i++)
	{
		double Thr_1 = pHData->m_pClustersThr[shift + (cur_index++)];
		double Thr_2 = pHData->m_pClustersThr[shift + (cur_index++)];

		for(j=0;j<256;j++)
		{
			if(lut[j] == -1)
			continue;

			double val = j;

			if(val>=Thr_1 && val<=Thr_2)
				ChildsLut[lut[j]] = i;
		}
	}

	pHData->FreeMemory();
	delete pHData;

	/*End of quantization*/

	delete [] stat;
	ImageRewind(GrayImage);
	return E2;
}

double InitChildsLut3(IMAGE *GrayImage, int *lut, int ElemNum, int* ChildsLut, int RN)
{
	ChildListItem *pCurChildItem=0;
	PixelsListItem *pCurPixItem=0;
	
	int i,j;
	double *stat;
	double total = 0;

	MULTITREE *TempTreeRoot;



	if(RN>=ElemNum)
		return 1;


	SetNColors(ElemNum);
	SetDelta((double)1/(double)ElemNum);
	TempTreeRoot = NewTreeNode();

	ConstructTreeImage(TempTreeRoot, GrayImage, lut, 1, 0);


	stat = (double*)malloc(sizeof(double)*ElemNum);


	memset(stat,0, sizeof(double)*ElemNum);

	//for(i = 0; i<ElemNum; i++)
	for(pCurChildItem=TempTreeRoot->pChildren;pCurChildItem;pCurChildItem=pCurChildItem->pNext)
	{
//		if(TempTreeRoot->Children[i])
		{
			ULONG *Pixels;
			ULONG total = 0;

			Pixels = new ULONG[ElemNum];

			total = 0;

			//for(j= 0;j < ElemNum; j++)
			for(pCurPixItem=pCurChildItem->pNode->pPixels;pCurPixItem;pCurPixItem=pCurPixItem->pNext)
			{
				//Pixels[j] = TempTreeRoot->Children[i]->Pixels[j];
				Pixels[pCurPixItem->PixelID] = pCurPixItem->Counter;
				total += Pixels[pCurPixItem->PixelID];
				printf("\n%d", Pixels[pCurPixItem->PixelID]);
			}

			stat[pCurChildItem->PixelID/*i*/] = GetEntropyAdapt(Pixels, total);

			free(Pixels);
		}
	}

	/*QUANTIZATION*/

	CHistoData      *pHData = NULL;
	pHData = new CHistoData(stat, ElemNum);

	double E2 = 0;
	pHData->DP_MSE(RN,2,2,&E2);

	int shift= (RN-1)*RN;
	int cur_index = 0;

	for(i=0;i<RN;i++)
	{
		double Thr_1 = pHData->m_pClustersThr[shift + (cur_index++)];
		double Thr_2 = pHData->m_pClustersThr[shift + (cur_index++)];

		for(j=0;j<ElemNum;j++)
		{
			double val = stat[j];

			if(val>=Thr_1 && val<=Thr_2)
				ChildsLut[j] = i;
		}
	}

	pHData->FreeMemory();
	delete pHData;

	/*End of quantization*/

	free(stat);
	DeallocateTree(TempTreeRoot);
	ImageRewind(GrayImage);
	return E2;
}

MULTITREE* GetContext(MULTITREE *CT, IMAGE *GrayImage, int* lut, int x, int y)
{
	MULTITREE *CCT;
	int p;
	int refx, refy;
	ChildListItem *pCurItem=0;

#ifdef TEMPLATE_2D
//    int  tJBIGX[31] = {30,-1,0,-1,+1,-2,0,-2,+2,-1,+1,-2,+2,-3,0,-3,+3,-1,+1,-3,+3,-2,+2,-4, 0,-4,+4,-1,+1,-3,+3 };
//    int  tJBIGY[31] = {30,0,-1,-1,-1,0,-2,-1,-1,-2,-2,-2,-2,0,-3,-1,-1,-3,-3,-2,-2,-3,-3, 0,-4,-1,-1,-4,-4,-3,-3 };
int  tJBIGX[36+1] = {36, 1, 0,-1, 0, 1,-1,-1, 1, 2, 0,-2, 0, 2,-1,-2, 1, 1,-2,-1, 2, 3, 0,-3, 0, 2,-2,-2, 2, 3,-1,-3, 1, 1,-3,-1, 3};
int  tJBIGY[36+1] = {36, 0, 1, 0,-1, 1, 1,-1,-1, 0, 2, 0,-2, 1, 2,-1,-2, 2, 1,-2,-1, 0, 3, 0,-3, 2, 2,-2,-2, 1, 3,-1,-3, 3, 1,-3,-1};

// Second template              //
//                              //
//            41 - 77           //
//                              //
//                              //
//           76 65 73           //
//        68 60 53 57 69        //
//     72 56 49 45 46 61 77     //
//     64 52 44 XX 42 50 62     //
//     75 59 48 43 47 54 70     //
//        67 55 51 58 66        //
//           71 63 74           //
//                              //
#endif


	CCT = CT;

	while(CCT->pChildren != NULL)
	{
		refx = x + tJBIGX[CCT->ChildPosition];
		refy = y + tJBIGY[CCT->ChildPosition];
		
		if((refx>=1 && refx <= (int)GrayImage->ImageSizeX) && (refy>=1 && refy <= (int)GrayImage->ImageSizeY))
			p = lut[GetGrayPixel(GrayImage,refx,refy)];
		else
			p = 0;


//		if(ChildsLut)
//			p = ChildsLut[p];

		pCurItem = FindChildItem(CCT,p);

		if(pCurItem/*CCT->Children[p]*/!=NULL)
			CCT = pCurItem->pNode;//CCT = CCT->Children[p];
		else
			break;
	}

	return CCT;
}

void AssignMostProbable(MULTITREE *pTree)
{
	PixelsListItem *pPixItem=0;
	ULONG max = pTree->pPixels->Counter;
	PixelsListItem *pmaxItem=pTree->pPixels;
	for(pPixItem=pTree->pPixels->pNext; pPixItem; pPixItem=pPixItem->pNext)
		if(pPixItem->Counter>pmaxItem->Counter)
		{
			max=pPixItem->Counter;
			pmaxItem=pPixItem;
		}
	pTree->pMostProbablePixelsItem = pmaxItem;

	if(pTree->pChildren)
	{
		ChildListItem *pCurChildItem = 0;
		for(pCurChildItem=pTree->pChildren;pCurChildItem;pCurChildItem=pCurChildItem->pNext)
			AssignMostProbable(pCurChildItem->pNode);
	}

}

void PruneFilter(MULTITREE *pTree, long Treshold)
{
	if(pTree->pChildren)
	{
		ChildListItem *pCurChildItem = 0;
		for(pCurChildItem=pTree->pChildren;pCurChildItem;)
		{
			if(pCurChildItem->pNode->Total<Treshold)
			{
				int id = pCurChildItem->PixelID;
				pCurChildItem=pCurChildItem->pNext;
				RemoveChildItem(pTree,id);
			}
			else
			{
				PruneFilter(pCurChildItem->pNode, Treshold);
			//	if(pCurChildItem)
				pCurChildItem=pCurChildItem->pNext;
			}
		}
	}
	else
	{
		
	}

}

void CalculateHistogram(MULTITREE *pTree, long* pHistogram, long* pFilteredHistogram, double Treshold)
{
	if(pTree->pChildren)
	{
		ChildListItem *pCurChildItem = 0;
		for(pCurChildItem=pTree->pChildren;pCurChildItem;pCurChildItem=pCurChildItem->pNext)
			CalculateHistogram(pCurChildItem->pNode, pHistogram, pFilteredHistogram, Treshold);
	}
	else
	{
		long index = pTree->Total;
		int counter=0;
		for(; index && (index>>1); )
		{
			index=index>>1;
			counter++;
		}

		pHistogram[counter]++;

		PixelsListItem *pPixItem=0;

		for(pPixItem=pTree->pPixels->pNext; pPixItem; pPixItem=pPixItem->pNext)
		{
			if((double)pPixItem->Counter/(double)pTree->pMostProbablePixelsItem->Counter<Treshold)
				pFilteredHistogram[counter]+=pPixItem->Counter;

//			if(pPixItem->Counter>pmaxItem->Counter)
//			{
//				max=pPixItem->Counter;
//			}

		}

//		PixelsListItem *pPixItem=0;
//		ULONG max = pTree->pPixels->Counter;
//		PixelsListItem *pmaxItem=pTree->pPixels;

//		for(pPixItem=pTree->pPixels->pNext; pPixItem; pPixItem=pPixItem->pNext)
//			if(pPixItem->Counter>pmaxItem->Counter)
//			{
//				max=pPixItem->Counter;
//				pmaxItem=pPixItem;
//			}

//		pTree->pMostProbablePixelsItem = pmaxItem;
/*
		for(pPixItem=pTree->pPixels; pPixItem; pPixItem=pPixItem->pNext)
			if((double)pPixItem->Counter/(double)pTree->pMostProbablePixelsItem->Counter<0.05)
			{
				PrintTree(pTree);
			}
*/	}
}

PixelsListItem* SelectReplacement(MULTITREE *CCT, double Treshold, int TresholdType)
{
	// Calculate total amount of non-filtered pixels
	ULONG NonFilteredTotal = 0;
	PixelsListItem *pPixItem=0;
	for(pPixItem=CCT->pPixels; pPixItem; pPixItem=pPixItem->pNext)
	{
		if(TresholdType==0)
			if((double)pPixItem->Counter/(double)CCT->Total>Treshold)
				NonFilteredTotal+=pPixItem->Counter;
		if(TresholdType==1)
			if((double)pPixItem->Counter/(double)CCT->pMostProbablePixelsItem->Counter>Treshold)
				NonFilteredTotal+=pPixItem->Counter;
	}
	// INITIALIZE PROBABILITY THRESHOLD LEVEL
	ULONG ProbabilityTresholdLevel=0;
	for(pPixItem=CCT->pPixels; pPixItem; pPixItem=pPixItem->pNext)
	{
		if(TresholdType==0)
			if((double)pPixItem->Counter/(double)CCT->Total>Treshold)
			{
				ProbabilityTresholdLevel=pPixItem->Counter;
				break;
			}
		if(TresholdType==1)
			if((double)pPixItem->Counter/(double)CCT->pMostProbablePixelsItem->Counter>Treshold)
			{
				ProbabilityTresholdLevel=pPixItem->Counter;
				break;
			}
	}
	if(!pPixItem) // everything is noise
		return 0;

	// if most probable is the only above the treshold
	if(ProbabilityTresholdLevel==NonFilteredTotal)
		return CCT->pMostProbablePixelsItem;

	srand ( time(NULL) );

	for(pPixItem=CCT->pPixels; pPixItem; pPixItem=pPixItem->pNext)
	{
		// IF UNDER TRESHOLD
		if( ((TresholdType==0)&&((double)pPixItem->Counter/(double)CCT->Total>Treshold)) ||
			((TresholdType==1)&&((double)pPixItem->Counter/(double)CCT->pMostProbablePixelsItem->Counter>Treshold)) )
		{
			ULONG random = rand() % NonFilteredTotal;
			if(random<=ProbabilityTresholdLevel)
				return pPixItem;
			else	// to be sure that one loop is enough for selecting the item
				ProbabilityTresholdLevel+=pPixItem->Counter;

			if(!pPixItem->pNext) // if last one is not selected yet
				return pPixItem; // then return it
		}
	}
	return 0;
}

//Osnovnaya funkciya: stroit po zadannomu IMAGE context tree, 
// i filtruet ego
ULONG MyGCTFilter(/*char* ImageName,*/IMAGE *GrayImage, IMAGE *OutputImage, int ContextSize, double Treshold, int TresholdType, int FilterType, int PruningTreshold, FLOW *f)
{
	int tempcount=0;
	int i;

	int ElemNum, pixelN;
	ULONG x,y;


	double Delta;

	double t1, t2, dt1;
	int HeaderSize, TreeSize;
	

	//FT
	int x_size = 5;
	int y_size = 6;
	int FreeTreeDepth = 8;
	int StartDepth = 0;

	ULONG FilteredCounter = 0;
	

	MULTITREE *Root;
//	TEMPLATEFT *RootFT;

	//DEBUG
//	ULONG ofs;
	

//	IMAGE GrayImage;
	int lut[256];
	int ChildsLut[256];
	int backlut[256];

	for(i=0;i<256;i++) { lut[i] = -1; ChildsLut[i] = i;}

	HeaderSize = 0;
//	ImageInit(ImageName, GrayImage, INPUT, 1, BUFACCESS, GRAYMODE, DISK, 40);
	
	LutInit(GrayImage, &ElemNum, &Delta, lut, backlut);

	int RN = 0;

	if(FreeTreeDepth > ContextSize)
		FreeTreeDepth = ContextSize;

	int SizeX, SizeY;


	SizeX = 0;
	SizeY = 0;

	if(!SizeX || !SizeY)
	{
		SizeX = GrayImage->ImageSizeX;
		SizeY = GrayImage->ImageSizeY;
	}
	
	HeaderSize = 0;

	SetNColors(ElemNum);
	SetDelta(Delta);

//	if(QUANTIZE_CHILDS == 1 && RN)
//		SetQuantizedNChilds(RN, ChildsLut);
	
//	if(!TREE_COMPLETE)
		SetCoeff(1);
//	else
//		SetCoeff(Delta);

	
	SetClusterSizes(SizeX, SizeY);
	int NumberOfClusters = GetNumberOfClustersMT(GrayImage);

	ULONG *Offsets;

	Offsets = (ULONG*)malloc(sizeof(ULONG)*NumberOfClusters);

// CREATE ROOT OF THE TREE
	Root = NewTreeNode();
	Root->ChildPosition = 1;


//	RootFT = NULL;
/*	
	if(FREE_TREE == 1)
	{
		RootFT = NewFTNode();
	}
*/

	if(StartDepth>=ContextSize)
		StartDepth = 0;

	int FirstDepth = 15;
	int SecondDepth = ContextSize;

	if(!StartDepth)
		SetAlreadyBuiltDepth(0, FirstDepth);
	else
		SetAlreadyBuiltDepth(0, 1000);

	FILE* file = fopen("zresults.txt","a");
	fprintf(file, "\nContext size = %i", ContextSize);
	fprintf(file, "\nThreshold = %.3f", Treshold);
	fprintf(file, "\nThreshold  Type = %i", TresholdType);
	fprintf(file, "\nFiltering  Type = %i", FilterType);
	fclose(file);//log file "zresults.txt"

	t1 = clock();

	ConstructTreeImage(Root,GrayImage,lut,ContextSize, 0);

//initialize backlut
	
//	for(i = 0; i < 256; i++)
//		if(lut[i]>=0)
//			backlut[lut[i]] = i;

	AssignMostProbable(Root);
/*
	long *pHistogram = new long[24];
	long *pFilteredHistogram = new long[24];

	memset(pHistogram,0,24*sizeof(long));
	memset(pFilteredHistogram,0,24*sizeof(long));

	CalculateHistogram(Root,pHistogram, pFilteredHistogram, Treshold);
	for(x=0; x<24; x++)
		printf("%i ",pHistogram[x]);
	printf("\n");
	for(x=0; x<24; x++)
		printf("%i ",pFilteredHistogram[x]);
	printf("\n");

	delete [] pHistogram;
	delete [] pFilteredHistogram;
*/
//	PrintTree(Root);
	PruneFilter(Root,PruningTreshold);
//	printf("===================================\n");
//	PrintTree(Root);
//	AssignMostProbable(Root);

//	PrintTree(Root);

// perform filtering

	double *pHistogram = new double[24];
	long *pFilteredHistogram = new long[24];

	memset(pHistogram,0,24*sizeof(double));
	memset(pFilteredHistogram,0,24*sizeof(long));

	for(y = 1; y <= GrayImage->ImageSizeY; y++)
	{
		for(x = 1; x <= GrayImage->ImageSizeX; x++)
		{
			pixelN = GetGrayPixel(GrayImage,x,y);
			pixelN = lut[pixelN];

			MULTITREE* CCT = GetContext(Root,GrayImage,lut,x,y);

			long index = CCT->Total;
			int counter=0;
			for(; index && (index>>1); )
			{
				index=index>>1;
				counter++;
			}
			pHistogram[counter]+=1/(double)CCT->Total;

			PixelsListItem *pPixItem = FindPixelsItem(CCT,pixelN);

			switch(TresholdType)
			{
				case 0:		// FILTERING BY ABSOLUTE PROBABILITY VALUE
					if((double)pPixItem->Counter/(double)CCT->Total<Treshold) // filtering percentage level
					{
						//FILTER THIS PIXEL
//						switch(FilterType)
//						{
//						case 0:
							PutGrayPixel(OutputImage,x,y,backlut[CCT->pMostProbablePixelsItem->PixelID]);
							FilteredCounter++;
//							break;


//						case 1:
//							PixelsListItem *pReplacer = SelectReplacement(CCT,Treshold,TresholdType);
//							if(pReplacer)
//								PutGrayPixel(OutputImage,x,y,backlut[pReplacer->PixelID]);
//							else	// everything was noise, put most probable
//								PutGrayPixel(OutputImage,x,y,backlut[CCT->pMostProbablePixelsItem->PixelID]);
//							FilteredCounter++;
//							break;

//						}
					}
					else
						PutGrayPixel(OutputImage,x,y,backlut[pixelN]);
					break;
				case 1:		// FILTERING RELATIVELY TO CONTEXT'S MOST PROBABLE PIXEL
					if((double)pPixItem->Counter/(double)CCT->pMostProbablePixelsItem->Counter<Treshold) // filtering percentage level
					{
						pFilteredHistogram[counter]++;

						//FILTER THIS PIXEL
						switch(FilterType)
						{
						case 0:
							PutGrayPixel(OutputImage,x,y,backlut[CCT->pMostProbablePixelsItem->PixelID]);
							FilteredCounter++;
							break;
						case 1:
							PixelsListItem *pReplacer = SelectReplacement(CCT,Treshold,TresholdType);
							if(pReplacer)
								PutGrayPixel(OutputImage,x,y,backlut[pReplacer->PixelID]);
							else	// everything was noise, put most probable
								PutGrayPixel(OutputImage,x,y,backlut[CCT->pMostProbablePixelsItem->PixelID]);
							FilteredCounter++;
							break;
						}
					}
					else
						PutGrayPixel(OutputImage,x,y,backlut[pixelN]);
					break;
			}
			
		}
//		if(QuietLevel>2) 
			UpdateProgressBar(y, GrayImage->ImageSizeY);
	}

	for(x=0; x<24; x++)
		printf("%f ",pHistogram[x]);
	printf("\n");
	for(x=0; x<24; x++)
		printf("%i ",pFilteredHistogram[x]);
	printf("\n");

	delete [] pHistogram;
	delete [] pFilteredHistogram;

	//DEBUG
//	CheckTheTree(Root);

//	FillRoot(Root);

	double Entropy = 0;
	int ContextNumber = 0;

	//DEBUG
//	OpenLogFile();
	SetRoot(Root);

	ULONG Total=0, Useless = 0;
	ULONG counter=0;

	TreeSize = (int)ceil((double)counter/(double)8);

	t2 = clock();

	dt1 = (t2-t1)/CLOCKS_PER_SEC;


//	printf("\n%.3f", Entropy/(double)(GrayImage->ImageSizeY*GrayImage->ImageSizeX));
//	printf("\n%.3f", (double)(counter + result*8 + HeaderSize*8)/(double)(GrayImage->ImageSizeY*GrayImage->ImageSizeX));

//	t2 = clock();
//	dt2 = (t2-t1)/CLOCKS_PER_SEC;

	file = fopen("zresults.txt","a");
	fprintf(file, "\nTime Taken  = %.3f", dt1);
	fclose(file);//log file "zresults.txt"
	
	
//	ImageDone(GrayImage);
	DeallocateTree(Root);

//	if(FREE_TREE == 1)
//		DeallocateFT(RootFT);

//	return CodeSize + HeaderSize + TreeSize;
	return FilteredCounter;
}



/*////////////////////////////////////////////////////////////*/
/* routines for universal sequential CT encoding*/
double SequentialEncodeData(char* InputFileName, char* OutputFileName, int depth)
{
	double result = 0;
	FLOW fin;
	FLOW fout;
	
	FILE *f1;
	FILE *f2;

	int i;

	f1 = fopen(InputFileName,"r");
	f2 = fopen(OutputFileName,"wb");

	InitFlow(&fin, F_FILE, f1, 1);
	InitFlow(&fout, F_FILE, f2, 1);


	BYTE *Data;
	int DataLength = 0;
//	BYTE ch;

//	while((ch = fgetc(f1))!=EOF)
//		DataLength++;

//	fseek(f1, 0, SEEK_SET);

	DataLength = 512*512;

	Data = (BYTE*)malloc(sizeof(BYTE)*DataLength);

	int ci = 0;

	for(i=0;i<DataLength;i++)
		Data[ci++] = fgetc(f1);


	MULTITREE *Root;

	Root = NewTreeNode();


	SetNColors(256);
	SetDelta(double(1)/double(256));
	SetCoeff(1);


	SetRoot(Root);
	ConstructTree(Root,Data, DataLength, depth);
	PruneTreeOptimal(Root);

	PrintTree(Root);

	DeallocateTree(Root);



	fclose(f1);
	fclose(f2);

	return result;
}


int FilterPGMImage(IMAGE* InputImage, IMAGE* OutputImage, int ContextSize, double Treshold, int TresholdType, int FilterType, int PruningTreshold, char *FileName )
{
	
	FLOW disk_flow;
	FILE *file;
	int NumberOfPartImages;

	int h_num, v_num;

	ULONG result;

//	IMAGE WholeGrayImage, OutputImage;

	file = fopen(FileName,"wb");
	InitFlow(&disk_flow,F_FILE,file,1);

//	ImageInit(ImageName, &WholeGrayImage, INPUT, 1, BUFACCESS, GRAYMODE, DISK, 10);

//	if(PartSizeX == 0 || PartSizeY == 0)
//	{
		NumberOfPartImages = 1;
		h_num = 1;
		v_num = 1;
//	}

//	SetImageSize(&OutputImage,WholeGrayImage.ImageSizeX,WholeGrayImage.ImageSizeY);
//	ImageInit(OutputName, &OutputImage, OUTPUT, 1, WHOLEIMAGE, GRAYMODE, DISK, 256);

	result = MyGCTFilter(InputImage, OutputImage, ContextSize, Treshold, TresholdType, FilterType, PruningTreshold, &disk_flow);

	PrintMessage("Pixels filtered: %i\n",result);

	file = fopen("zresults.txt","a");
//	fprintf(file, "\n Overal Bit rate %.3f", (double)(FileSize*8)/(double)(WholeGrayImage.ImageSizeX*WholeGrayImage.ImageSizeY));
	fprintf(file, "\n Pixels filtered : %i",result);
	fclose(file);

//	ImageDone(&WholeGrayImage);
//	ImageDone(&OutputImage);
	fclose(file);
	return 1;
}