#ifndef GENCODER_H
#define GENCODER_H

#include "../Modules/owntypes.h"
#include "../Modules/genio.h"

// Function prototypes for Q-based coders

typedef void (*TInitCoder)(void *, FLOW *, int);

#ifdef ENTROPY
typedef void (*TEncode)(void *, int, void*, double *);
#else 
typedef void (*TEncode)(void *, int, void*);
#endif

typedef BOOLN (*TDecode)(void *, void*);
typedef ULONG (*TFlush)(void *);

// Structures

typedef struct tagGenericCoder
{
  void         *Coder;

  TInitCoder   InitCoder;
  TEncode      Encode;
  TDecode      Decode;
  TFlush       Flush;
} GENCODER;

YESNO GENPrepareCoder(GENCODER *, int, int);
void GENDoneCoder(GENCODER *);

#endif //GENCODER_H
