#ifndef GENMODEL_H
#define GENMODEL_H

#include "../Modules/owntypes.h"
#include "../Modules/genio.h"

// Types

#define  FormatNameMODEL    "mt"

typedef YESNO (*TInitModel)(void *, ULONG, int, int, int);
typedef void  (*TReInitModel)(void *);
typedef void  (*TDoneModel)(void *);
typedef void  (*TCreateInitialModel)(void *, ULONG *, ULONG *);
typedef int   (*TStoreModel)(void *, FLOW *flow);
typedef int   (*TLoadModel)(void *, FLOW *flow);

typedef enum {FORWARDADAPTIVE, ADAPTIVE} MODELLINGTYPE;
typedef enum {ENCODING, DECODING} PROCESSTYPE;

typedef struct tagGENMODEL
{
  ULONG         Size;
  ULONG         NModels;
  int           NSymbols;
  PROCESSTYPE   Process;
  MODELLINGTYPE ModellingType;

  void         *Model;
  double       *FastAttack;
  int          *FastAttackStateNumber;

  TCreateInitialModel   CreateInitialModel;
  TInitModel            InitModel;
  TReInitModel          ReInitModel;
  TDoneModel            DoneModel;
  TStoreModel           StoreModel;
  TLoadModel            LoadModel;
} GENMODEL;


YESNO GENPrepareModel(GENMODEL *, int EncoderType);

#endif //GENMODEL_H
