#ifndef MQCODER_H
#define MQCODER_H

#include <stdio.h>
#include "../Modules/owntypes.h"
#include "../Modules/genio.h"
#include "qmodel.h"

typedef struct tagMQDEC
{
  ULONG C;
  ULONG A;
  ULONG CT;
  BYTE inBuffer;
  BOOLN bEOF;
  ULONG BytesCount;
  FLOW *pCodeStream;
  TInputByte fByteIn;

  int  mask;
} MQDEC;

typedef struct tagMQENC
{
  ULONG C;
  ULONG A;
  ULONG CT;

  BYTE outBuffer;
  BOOLN bFirstByte;
  BOOLN bLastByte;
  ULONG nFF;
  ULONG n7F;
  ULONG BytesCount;
  FLOW *pCodeStream;
  TOutputByte fByteOut;

  int  mask;
} MQENC;


void MQInitEncoder(MQENC*, FLOW*, int);
void MQEncode(MQENC*, int, void*);
void MQEncodeStats(MQENC*, int, void*, double*);
ULONG MQFlushEncoder(MQENC*);

void MQInitDecoder(MQDEC*, FLOW*, int);
BOOLN MQDecode(MQDEC*, void *);
ULONG MQFlushDecoder(MQDEC*);

#endif

