#ifndef QMCODER_H
#define QMCODER_H

#include "qmodel.h"
#include "../Modules/owntypes.h"

typedef struct tagQMDEC
{
  ULONG C;
  UINT16 A;
  ULONG CT;             /* Shift counter */
  ULONG BytesCount;

  int  buffer;          /* Bits buffered for output or input */
  int  stflag;          /* Flag to inhibit first write */
  int  nzero;           /* Potential trailing zeros */
  int  sc;              /* Number of FF bytes */
  int  pacfeed;         /* End Of Code flag */
  FLOW *pCodeStream;    /* Used together with Input/Output byte functions */
  TInputByte fByteIn;

  int  mask;
} QMDEC;

typedef struct tagQMENC
{
  ULONG C;
  UINT16 A;
  ULONG CT;             /* Shift counter */
  ULONG BytesCount;

  int  buffer;          /* Bits buffered for output or input */
  int  stflag;          /* Flag to inhibit first write */
  int  nzero;           /* Potential trailing zeros */
  int  sc;              /* Number of FF bytes */
  int  pacfeed;         /* End Of Code flag */
  void *pCodeStream;
  TOutputByte fByteOut;

  int  mask;
} QMENC;


void QMInitEncoder(QMENC*, FLOW*, int);
void QMEncode(QMENC*, int, void*);
void QMEncodeStats(QMENC*, BOOLN, void*, double*);
ULONG QMFlush(QMENC*);

void QMInitDecoder(QMDEC*, FLOW*, int);
int QMDecode(QMDEC*, void *);

/*----------------- Interface for forward-adative QM -----------------*/
//int QMGetFirstAttackStateIndex(double);
//void QMRestoreFirstAttackStateIndex(BYTE*, BYTE*, int);

#endif
