#ifndef QSMODEL_H
#define QSMODEL_H

#include <stdio.h>  // FILE*
#include "../Modules/owntypes.h"
#include "genmodel.h"
#include "../Modules/genio.h"


#define TBLSHIFT 7
#define BITSINCNT 12

/*#define TBLSHIFT 7
#define BITSINCNT 15
*/

typedef struct 
{
  int n;             // number of symbols
  int left,          // symbols to next rescale
      nextleft,      // symbols with other increment
      rescale,       // intervals between rescales
      targetrescale, // should be interval between rescales
      incr,          // increment per update
      searchshift;   // shift for lt_freq before using as index
  UINT16 *cf,        // array of cumulative frequencies
         *newf,      // array for collecting statistics
         *search;    // structure for searching on decompression
  
  UINT16 *init;         // for semiadaptive modeling

} QSMODEL;


YESNO InitQSModel(GENMODEL*, ULONG, int, int, int );
void  DoneQSModel(GENMODEL*);
void  ReInitQSModel(GENMODEL*);

void  dorescale(QSMODEL*);
void initqsmodel(QSMODEL *m, int n, int lg_totf, int rescale, PROCESSTYPE process);
// FA
void CreateInitialQSModel(GENMODEL*, ULONG*, ULONG*);
int  StoreInitialQSModel(GENMODEL *, FLOW *f);
int  LoadInitialQSModel(GENMODEL *, FLOW *f);

#endif //QSMODEL_H
