#ifndef RNGCODER_H
#define RNCGODER_H

#include "../Modules/owntypes.h"
#include "qsmodel.h"
#include "../Modules/genio.h"

typedef UINT32 CODE_VALUE;      
// Type of an rangecode value must accomodate 32 bits

// it is highly recommended that the total frequency count is less
// than 1 << 19 to minimize rounding effects.
// the total frequency count MUST be less than 1<<23

typedef struct
{     //low end, length of interval, and bytes_to_follow resp. intermediate value
  CODE_VALUE low, range, help;          
  BYTE buffer;                        // buffer for input/output
                                      // the following is used only when encoding
  ULONG BytesCount;                   // counter for outputed bytes

  TInputByte fByteIn;
  TOutputByte fByteOut;
  FLOW *pCodeStream;                       // Abstract I/O flow
                                                                                                  
  int  pacfeed;                       // End Of Code flag
  int  mask;
} RCENC;

void   RCInitEncoder(RCENC*, FLOW*, int);
ULONG  RCFlushEncoder(RCENC*rc);
void   RCInitDecoder(RCENC*, FLOW*, int);
ULONG  RCFlushDecoder(RCENC *rc);
void   RCEncode(RCENC*, int, QSMODEL*);
int    RCDecode(RCENC*, QSMODEL*);
void qsupdate(QSMODEL *m, int sym );


#endif //RNCGODER_H
