#if !defined(__OWNTYPES_H)
#define __OWNTYPES_H
/*-------------------------------------------------------------------*/
/* OWNTYPES.H      Juha Kivijrvi                                    */
/*                                                                   */
/* Own type definitions and useful macros                            */
/*                                                                   */
/* version       0.02a                                               */
/* last updated  29.4.96                                             */
/*                                                                   */
/*-------------------------------------------------------------------*/

#include <limits.h>

typedef  enum { NO=0, YES=1 }  YESNO;
#define NOEX -1

#define  MAXLLONG              0x7fffffffffffffff
#define  LOG2                  0.693147180559945286  // P.Kopylov + E.Ageenko
#define  DELTA                 0.45                  // estimator starting probability, JBIG

#if defined(round)                                   // P.Kopylov + E.Ageenko
#undef round                                         // P.Kopylov + E.Ageenko
#endif                                               // P.Kopylov + E.Ageenko
#define round(a)      ( (int) ((a) + 0.5) )          // P.Kopylov + E.Ageenko

#if defined(max) || defined(min)
#undef max
#undef min
#endif
#define  max(a,b) ((a) > (b) ? (a) : (b))
#define  min(a,b) ((a) < (b) ? (a) : (b))
#define  ScaleBetween(a,b,c)   max((a), min((b), (c)))

#ifndef ulong 
typedef unsigned long ulong;
#endif
#ifndef uint 
typedef unsigned int  uint;
#endif
#ifndef byte
typedef unsigned char byte;
#endif
#ifndef llong 
typedef __int64 llong;
#endif

typedef unsigned long ULONG;  // P.Kopylov + EA // big enough unsigned long type (assume at least 32bit)
typedef long          SLONG;  // P.Kopylov + EA // -"- for operations with signed numbers
typedef unsigned int  BOOLN;  // P.Kopylov + EA // for 0 or 1 only, length determined by platform
#ifndef UINT
typedef unsigned int  UINT;   // P.Kopylov + EA // some unsigned flag (at least 8 bit) for biwise ops
#endif
typedef signed int    SINT;   // P.Kopylov + EA // some counter, length determined by platform
#ifndef BYTE
typedef unsigned char BYTE;  // byte
#endif

typedef BYTE* PBYTE; // P.Kopylov
typedef long* PLONG; // E.Ageenko


#if INT_MAX > 0x7FFF            // E.Ageenko & P.Kopylov
typedef unsigned short UINT16;  // 2-byte integer exactly
typedef unsigned int   UINT32;  // 4-byte integer exactly
#else
typedef unsigned int   UINT16;  // 2-byte integer exactly
typedef unsigned long  UINT32;  // 4-byte integer exactly
#endif



#define  roundint(a)           ( a>0?(SINT) ((a) + 0.5):(SINT)((a)-0.5) )
#define sign(a)    (a>0?1:-1)

#ifdef GCC
#define Inline inline
#else
#define Inline __inline
#endif

// P. Kopylov - moved from pgm
typedef  enum { UNKNOWN=0, PBM=1, PGM=2, PPM=3, PGMASCII=4, PGMEXTENDED=5, PRJ=6} FILETYPE;


#endif /* __OWNTYPES_H */
