/*-------------------------------------------------------------------*/
/* COLORDISTANCE.C     Pavel Kopylov                                 */
/*                                                                   */
/*-------------------------------------------------------------------*/

#define ProgName        "COLORDISTANCE"
#define VersionNumber   "0.02"
#define LastUpdated     "04.06.2003"

/* ------------------------------------------------------------------*/

#include "owntypes.h"
#include "cb.h"
#include "colordis.h"
#include "interfc.h"
#include "color.h"


double CIE76_D2D(TRAININGSET* TS, CODEBOOK* CB, PARTITIONING* PA, int From, int To, int Direction)
{
  VECTORTYPE F, T;
  F = Vector(TS, From);
  T = Vector(TS, To);
  return ColorDistance76(D65, (BYTE)F[0], (BYTE)F[1], (BYTE)F[2], (BYTE)T[0], (BYTE)T[1], (BYTE)T[2]);
}

double CIE76_D2M(TRAININGSET* TS, CODEBOOK* CB, PARTITIONING* PA, int From, int To, int Direction)
{
  VECTORTYPE F, T;
  F = Vector(TS, From);
  T = Vector(CB, To);
  return ColorDistance76(D65, (BYTE)F[0], (BYTE)F[1], (BYTE)F[2], (BYTE)T[0], (BYTE)T[1], (BYTE)T[2]);
}

double CIE76_M2D(TRAININGSET* TS, CODEBOOK* CB, PARTITIONING* PA, int From, int To, int Direction)
{
  VECTORTYPE F, T;
  F = Vector(CB, From);
  T = Vector(TS, To);
  return ColorDistance76(D65, (BYTE)F[0], (BYTE)F[1], (BYTE)F[2], (BYTE)T[0], (BYTE)T[1], (BYTE)T[2]);
}

double CIE76_M2M(TRAININGSET* TS, CODEBOOK* CB, PARTITIONING* PA, int From, int To, int Direction)
{
  VECTORTYPE F, T;
  F = Vector(CB, From);
  T = Vector(CB, To);
  return ColorDistance76(D65, (BYTE)F[0], (BYTE)F[1], (BYTE)F[2], (BYTE)T[0], (BYTE)T[1], (BYTE)T[2]);
}

double CIE94_D2D(TRAININGSET* TS, CODEBOOK* CB, PARTITIONING* PA, int From, int To, int Direction)
{
  VECTORTYPE F, T;
  F = Vector(TS, From);
  T = Vector(TS, To);
  return ColorDistance94(D65, (BYTE)F[0], (BYTE)F[1], (BYTE)F[2], (BYTE)T[0], (BYTE)T[1], (BYTE)T[2]);
}

double CIE94_D2M(TRAININGSET* TS, CODEBOOK* CB, PARTITIONING* PA, int From, int To, int Direction)
{
  VECTORTYPE F, T;
  F = Vector(TS, From);
  T = Vector(CB, To);
  return ColorDistance94(D65, (BYTE)F[0], (BYTE)F[1], (BYTE)F[2], (BYTE)T[0], (BYTE)T[1], (BYTE)T[2]);
}

double CIE94_M2D(TRAININGSET* TS, CODEBOOK* CB, PARTITIONING* PA, int From, int To, int Direction)
{
  VECTORTYPE F, T;
  F = Vector(CB, From);
  T = Vector(TS, To);
  return ColorDistance94(D65, (BYTE)F[0], (BYTE)F[1], (BYTE)F[2], (BYTE)T[0], (BYTE)T[1], (BYTE)T[2]);
}

double CIE94_M2M(TRAININGSET* TS, CODEBOOK* CB, PARTITIONING* PA, int From, int To, int Direction)
{
  VECTORTYPE F, T;
  F = Vector(CB, From);
  T = Vector(CB, To);
  return ColorDistance94(D65, (BYTE)F[0], (BYTE)F[1], (BYTE)F[2], (BYTE)T[0], (BYTE)T[1], (BYTE)T[2]);
}

