#if ! defined(__INTERFC_H)
#define __INTERFC_H

/* ---------------------- INFORMATION OUTPUT --------------------------*/

#define  ERRMSG(msg) {ErrorMessage((msg)); ExitProgram(-1);}
#define  ERRMSGP(msg,p) {ErrorMessage((msg),(p)); ExitProgram(-1);}

#define  TRY(function,msg) if ((function)!=YES) \
         {ErrorMessage((msg)); ExitProgram(-1);} else;
#define  TRYNULL(function,msg) if ((function)==NULL) \
         {ErrorMessage((msg)); ExitProgram(-1);} else;
#define  TRY0(function,msg) if ((function)==0) \
         {ErrorMessage((msg)); ExitProgram(-1);} else;
#define  TRYVAL(function,val,msg) if ((function)!=(val)) \
         {ErrorMessage((msg)); ExitProgram(-1);} else;
#define  TRYIT(function,val,msg) if ((function)==(val)) \
         {ErrorMessage((msg)); ExitProgram(-1);} else;
#define  TRYNEG(function,msg) if ((function)<0) \
         {ErrorMessage((msg)); ExitProgram(-1);} else;

#define  RETNO(function) if ((function)!=YES) return(NO); else;
#define  RETNULL(function) if ((function)==NULL) return(NO); else;
#define  RETVAL(function,val) if ((function)!=(val)) return(NO); else;

int PrintMessage(char *format, ...);
int PrintErrorMessage(char *format, ...);
int ErrorMessage(char *format, ...);
int MessageWithQuestion(char *format, ...);

/* GUI:     everything goes to "Process Output" -window   */
/* CONSOLE: 0 - all to stdout, 1 - PrintMessage to stderr */
int OpenInfoFlow(int id);
int CloseInfoFlow(void);

/* --------------------- PROGRAM TERMINATION --------------------------*/

typedef enum { EVERYTHING_OK=0,
                FATAL_ERROR=-1,
                EXIT_REQUEST_HONOURED=-2,
                RECOVERABLE_ERROR=-3,
                RECOVERABLE_ERROR_UNCONTROLLED_EXIT=-4
                } ReservedExitProcessReturnValues;

extern void ExitProcessing(int ReturnValue);
extern int ExitRequestHonored();
extern void SetExitRequestHonored(int Honoured);
extern int ExitRequested();


/* ---------------------- PROGRESS INDICATOR --------------------------*/

int SetProgressVisibility(int true_false);  /* its quiet level */
int OpenProgressWindow(void);
int CloseProgressWindow(void);
int UpdateProgressBar(int processedsamples, int samplestotal);
int UpdateFancyProgressBar(int processedsamples, int samplestotal);
int UpdateProgressLabel(char *format, ...);
int FreezeProgress(int true_false);
int ExitProgram (int value);

/*--------------------------------------------------------------------*/

#endif /* __INTERFC_H */
