#if !defined(__MAPSEG_H)
#define __MAPSEG_H

#include "owntypes.h"
#include "project.h"
#include "image.h"
#include "cb.h"

typedef struct
{
  int   QuietLevel;
  int   Separation;
  int   Colors;
  int   IterRLS;
  int   IterGLA;
  int   Trees;
  int   GrayCode;
  int   Distance;
  int   CI;
  int   CutOff;
  int   tweak;
  int   Threshold;
} SEGMPARAMS;

struct idMULTITREEm
{
  struct idMULTITREEm  **Children;
  SLONG               index;
  ULONG               freq;
};
typedef struct idMULTITREEm MULTITREEm;

/*-------------------------------------------------------------------*/
YESNO    mapseg(PROJECTDATA *Project, SEGMPARAMS *Params);
YESNO    mapreconst(PROJECTDATA *Project);
YESNO    bitseg(PROJECTDATA *Project, SEGMPARAMS *Params);
YESNO    bitreconst(PROJECTDATA *Project, YESNO GrayCode);
void     ColorSeparation(IMAGE* QuantizedImage, PROJECTDATA *Project, SEGMPARAMS *Params, TRAININGSET* TS, 
                         CODEBOOK* CB, PARTITIONING* PA, MULTITREEm* MT);
void     BitSeparation(IMAGE* QuantizedImage, char *OutputName, YESNO GrayCode);
void     ColorSeparationEx(IMAGE* QuantizedImage, IMAGE **ImageArray, TRAININGSET* TS, CODEBOOK* CB, 
                           PARTITIONING* PA, MULTITREEm* MT);
void     BitSeparationEx(IMAGE* QuantizedImage, IMAGE **ImageArray, YESNO GrayCode);
YESNO    AnalyzeBackground(PROJECTDATA *Project);
int      CompareNodes(void* a, void* b, void* info, int tweak);
int      GetColorIndex(TRAININGSET* TS, CODEBOOK* CB, PARTITIONING* PA, MULTITREEm* MT, RGBPIXEL color, RGBPIXEL color1);
RGBPIXEL GetColorByIndex(CODEBOOK* CB, int Index);
void     InitializeTrainingSet(TRAININGSET* TS, int size, int maxvalue, int dim);
ULONG    ReadVectors(CODEBOOK* CB, int tweak);
YESNO    SaveColorMap(PROJECTDATA *Project);
void     PrintCodeBook(CODEBOOK* CB, int tweak);
void     CutOff0(SEGMPARAMS *Params, TRAININGSET *TS, MULTITREEm* MT);
void     CutOff1(SEGMPARAMS *Params, TRAININGSET *TS, MULTITREEm* MT);

ULONG    ConstructColorTree(MULTITREEm **MT, IMAGE* Image, IMAGE* Layer, int QuietLevel, int tweak, int threshold);
void     ConvertTreeToTrainingSet(TRAININGSET* TS, MULTITREEm *MT, int NColors, int tweak);
void     DeallocateMTree(MULTITREEm *MT);

#endif /* __MAPSEG_H */
