#if ! defined(__MEMCTRL_H)
#define __MEMCTRL_H

/* ----------------------------------------------------------------- */

/* Uncomment the following define if You do not want to use
   the memorycontroller. */
/*#define NO_MEMORYCONTROLLER 

/* Comment the following define if You do not want to exit
   when out of memory. */
// #define EXIT_WHEN_MEMORYCONTROLLER_FAILS

/* Uncomment next line if You want to use "Amount Control".
 */
/* #define AMOUNTCONTROL */


/* ----------------------------------------------------------------- */

#if ! defined(NO_MEMORYCONTROLLER)

#include <string.h>


#if defined(AMOUNTCONTROL)
extern unsigned long _allocated;    /* # of bytes that are currently allocated. */
extern unsigned long _maxallocated; /* Max. # of bytes that has been allocated */
#endif
extern unsigned long _nallocated;   /* # of allocation calls */
extern unsigned long _ndeallocated; /* # of deallocation calls */

void  memoryreport(void);
int  checkmemory(void);
void* allocatememory(size_t nbytes, char* file, int line);
void  deallocate(void* block);
unsigned long usedmemory(void);


#define allocate(nbytes)  allocatememory(nbytes, __FILE__, __LINE__)

#else

#include <stdlib.h>

#define memoryreport()
#define checkmemory()        0
#define allocate(nbytes)     malloc(nbytes)
#define deallocate(block)    free(block)

#endif

/* ----------------------------------------------------------------- */

#endif /* __MEMCTRL_H */

