#if ! defined(__PROJECT_H)
#define __PROJECT_H

#include "owntypes.h"
//#include "vector.h"
#include "color.h"

#define FormatNamePRJ  "mpr"


/*------------------------------------------------------*/

typedef struct
{
  UINT32   LayerIndex;
  UINT32   LayerType;
  UINT32   LayerDependency;
  char     LayerFileName[127];
}PROJECTPARAMETERS;

typedef struct
{
  UINT32   LayerIndex;
  char     LayerFileName[127];
}TREEPARAMETERS;

typedef struct
{
  UINT32   LayerIndex;
}MODELPARAMETERS;

typedef struct
{
  UINT32      LayerIndex;
  UINT		  NumberOfColors;
  RGBPIXEL   *Colors;
}COLORINFO;
/*------------------------------------------------------*/
typedef struct
{
  UINT32      LayerIndex;
  RGBPIXEL   Color;
}COLORPARAMETERS;

/*------------------------------------------------------*/
typedef struct
{ 
  char                ProjectName[80];
  char                InputName[80];
  char                OutputName[80];
  UINT                Layers;
  UINT                Trees;
  UINT                Models;
  UINT                XSize;
  UINT                YSize;
  UINT			      Colors;

  UINT32			  BackGround;
  double              LeftBottomX;
  double              LeftBottomY;
  double              RightTopX;
  double              RightTopY;
  double              Scale;
  double              Rotation;
  PROJECTPARAMETERS   *ProjectParams;
  TREEPARAMETERS      *Tree;
  MODELPARAMETERS     *Model;
  COLORPARAMETERS     *Color;
}PROJECTDATA;
/*------------------------------------------------------*/
typedef struct
{ 
  char                ProjectName[80];
  char                InputName[80];
  char                OutputName[80];
  UINT                Layers;
  UINT                Trees;
  UINT                Models;
  UINT                XSize;
  UINT                YSize;
  UINT			      Colors;

  UINT32			  BackGround;
  double              LeftBottomX;
  double              LeftBottomY;
  double              RightTopX;
  double              RightTopY;
  double              Scale;
  double              Rotation;
  PROJECTPARAMETERS   *ProjectParams;
  TREEPARAMETERS      *Tree;
  MODELPARAMETERS     *Model;
  COLORINFO			  *Color;
}MY_PROJECTDATA;


/* ---- Interface project functions -------------------------------- */
void  CreateEmptyProject(PROJECTDATA*);
YESNO SaveProject(PROJECTDATA*);
YESNO ReadProject(PROJECTDATA*);
YESNO DoneProject(PROJECTDATA*);
YESNO ReadList(char *InputName, int *Size, int **List);
void  PrintProject(PROJECTDATA*, int QuiteLevel);
YESNO DeleteItem(PROJECTDATA*, ULONG);
YESNO DoneList(int *List);
#endif /* __PROJECT_H */

