/*-------------------------------------------------------------------*/
/* SHAPE.C     Pavel Kopylov                                         /*
/*                                                                   */
/* Shape collection to avoid multiple declarations                   */
/*-------------------------------------------------------------------*/

#define ProgName        "SHAPE"
#define VersionNumber   "0.01"
#define LastUpdated     "05.10.2003"

#include "shape.h"


int Circle37X[38] = {36, 1, 0,-1, 0, 1,-1,-1, 1, 2, 0,-2, 0, 2,-1,-2, 1, 1,-2,-1, 2, 3, 0,-3, 0, 2,-2,-2, 2, 3,-1,-3, 1, 1,-3,-1, 3, 0};
int Circle37Y[38] = {36, 0, 1, 0,-1, 1, 1,-1,-1, 0, 2, 0,-2, 1, 2,-1,-2, 2, 1,-2,-1, 0, 3, 0,-3, 2, 2,-2,-2, 1, 3,-1,-3, 3, 1,-3,-1, 0};
int Circle37M[38] = {37,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,37};
//           35 24 32		
//        27 19 12 16 28	
//     31 15  7  4  8 20 36
//     23 11  3  ?  1  9 21
//     34 18  6  2  5 13 29
//        26 14 10 17 25	
//           30 22 33		

int Circle1_37X[22] = {20, 0, 2, 0,-2, 0, 3, 0,-3, 2, 2,-2,-2, 0, 1, 0,-1, 1, 1,-1,-1, 0};
int Circle1_37Y[22] = {20,-2, 0, 2, 0,-3, 0, 3, 0,-2, 2, 2,-2,-1, 0, 1, 0,-1, 1, 1,-1, 0};
int Circle1_37M[22] = {21,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,21};
//               5 		
//        12     1    9	
//           20 13 17    
//      8  4 16  ? 14 2  6
//           19 15 18 
//        11     3    10	
//               7 		

int  Block3x3X[10] = {9, 0,-1, 0, 1, 0,-1,+1,-1,+1};
int  Block3x3Y[10] = {9, 0, 0,-1, 0, 1,-1,-1,+1,+1};
int  Block3x3M[10] = {9, 8,-1,-1,-1,-1,-1,-1,-1,-1};

/*       Block 3 x 3             weights          */
/*                                                */
/*         6  3  7              -1 -1 -1          */
/*         2  1  4              -1  8 -1          */
/*         8  5  9              -1 -1 -1          */

int  FSEDX[5] = {4, 1,-1, 0, 1};
int  FSEDY[5] = {4, 0, 1, 1, 1};
int  FSEDM[5] = {4, 7, 3, 5, 1};

/*       FSED 3 x 3             weights           */
/*                                                */
/*            P  1                     7          */
/*         2  3  4               3  5  1          */


extern int *TemplateArray[4][3]= 
{
  {Circle37X,Circle37Y,Circle37M},
  {Circle1_37X,Circle1_37Y,Circle1_37M},  // for future shapes
  {Block3x3X,Block3x3Y,Block3x3M},
  {FSEDX,FSEDY,FSEDM}};

int  *TemplateX, *TemplateY, *TemplateM;


/* first pixel must not be origin */

int KernelX[][50]={{0,0,1,1,-1,-1,-1,0,1}, /* (0)     o o o  (1)       o   */
                   {0,1,0,-1,0},           /* BLOCK:  o o o  CROSS:  o o o */
                   {0,1,1,1,0,-1,-1,-1},   /*         o o o            o   */
/*         */      {0,1,0,-1},             /*                              */
/* (10)    */      {0,0,0},                /* (2)     5 4 3  (3)       2   */
/* XCROSS  */      {1,0,-1},               /* ABLOCK: 6 . 2  ACROSS: 3 . 1 */
/*         */      {0,0},                  /*         7 0 1            0   */
/*  o . o  */      {1,-1},                 /*                              */
/*  . o .  */      {-1,0,-1,0},            /* (8)      o o   (9)      o x  */
/*  o . o  */      {0,1,0,1},              /* BLOCK2:  x o   BLOCK2T: o o  */
/*         */      {-1,1,0,-1,1},
                   {-1,1,1,-1}};

int KernelY[][50]={{1,0,0,1,1,0,-1,-1,-1}, /* (4)       o    (5)           */
                   {1,0,0,0,-1},           /* VBAR:     o    HBAR:   o o o */
                   {1,1,0,-1,-1,-1,0,1},   /*           o                  */
/*         */      {1,0,-1,0},             /*                              */
/* (11)    */      {1,0,-1},               /* (6)       2    (7)           */
/* XACROSS */      {0,0,0},                /* AVBAR:    .    AHBAR:  2 . 1 */
/*         */      {1,-1},                 /*           1                  */
/*  3 . 2  */      {0,0},                  /*                              */
/*  . . .  */      {1,1,0,0},              /* note (8) is actually transposed */
/*  0 . 1  */      {0,0,-1,-1},            /* due to specific way of applying */
/*         */      {1,1,0,-1,-1},          /* morph.operators trough the rank */
                   {1,1,-1,-1}};

char KernelN [15]={9,5,8,4,3,3,2,2,4,4,5,4};

typedef enum   { BLOCK=0,CROSS=1,ABLOCK=2,ACROSS=3,VBAR=4,HBAR=5,
                 AVBAR=6,AHBAR=7,BLOCK2=8,BLOCK2T=9,
/* extended */   XCROSS=10, AXCROSS=11
               } SELEMENT;


/*-------------------------------------------------------------------*/

/*  JBIG extended template   */
/*                           */
/*      21 17 14 18 22       */
/*   19 11  9  6 10 12 20    */
/*   15  7  3  2  4  8 16    */
/*   13  5  1  ?             */
/*                           */


int  JBIGX[31] = {30,-1,0,-1,+1,-2,0,-2,+2,-1,+1,-2,+2,-3,0,-3,+3,-1,+1,-3,+3,-2,+2,-4, 0,-4,+4,-1,+1,-3,+3 };
int  JBIGY[31] = {30,0,-1,-1,-1,0,-2,-1,-1,-2,-2,-2,-2,0,-3,-1,-1,-3,-3,-2,-2,-3,-3, 0,-4,-1,-1,-4,-4,-3,-3 };

/*    JBIG extended template   */
/*           27 24 28          */
/*     29 21 17 14 18 22 30    */
/*     19 11  9  6 10 12 20    */
/*  25 15  7  3  2  4  8 16 26 */
/*  23 13  5  1  ?             */
/*                             */

int  ClairX[25] = {24,-1,0,1,0,-1,+1,-1,+1,-2,0,2,0,-2,+2,-2,+2,-1,+1,-1,+1,-2,+2,-2,+2 };
int  ClairY[25] = {24,0,-1,0,1,-1,-1,+1,+1,0,-2,0,2,-1,-1,+1,+1,-2,-2,+2,+2,-2,-2,+2,+2 };

/*   Clairvoyant template    */
/*                           */
/*      21 17 10 18 22       */
/*      13  5  2  6 14       */
/*       9  1  ?  3 11       */
/*      15  7  4  8 16       */
/*      23 19 12 20 24       */
/*                           */

int  DefTemplateX[MISSTEMPLATESIZE+1] = {MISSTEMPLATESIZE,-1, 0,-1,+1,-2, 0,-2,+2,-1,+1,-2,+2,-3, 0,-3,+3,-1,+1,-3,+3,-2,+2,-4, 0,-4,+4,-1,+1,-3,+3,-4,+4,-2,+2,-4,+4,-3,+3,-4,+4 };
int  DefTemplateY[MISSTEMPLATESIZE+1] = {MISSTEMPLATESIZE, 0,-1,-1,-1, 0,-2,-1,-1,-2,-2,-2,-2, 0,-3,-1,-1,-3,-3,-2,-2,-3,-3, 0,-4,-1,-1,-4,-4,-3,-3,-2,-2,-4,-4,-3,-3,-4,-4,-4,-4 };

// JBIG extended template (PFA) //
//                              //
//              40              //
//                              //
//  39 37 33 27 24 28 34 38 40  //
//  35 29 21 17 14 18 22 30 36  //
//  31 19 11  9  6 10 12 20 32  //
//  25 15  7  3  2  4  8 16 26  //
//  23 13  5  1  ?              //
//                              //

int LayerTemplateX[MISSDEPTEMPLATESIZE+1] = {MISSDEPTEMPLATESIZE,0, 1, 0,-1, 0, 1,-1,-1, 1, 2, 0,-2, 0, 2,-1,-2, 1, 1,-2,-1, 2, 3, 0,-3, 0, 2,-2,-2, 2, 3,-1,-3, 1, 1,-3,-1, 3};
int LayerTemplateY[MISSDEPTEMPLATESIZE+1] = {MISSDEPTEMPLATESIZE,0, 0, 1, 0,-1, 1, 1,-1,-1, 0, 2, 0,-2, 1, 2,-1,-2, 2, 1,-2,-1, 0, 3, 0,-3, 2, 2,-2,-2, 1, 3,-1,-3, 3, 1,-3,-1};

// Second template              //
//                              //
//            41 - 77           //
//                              //
//                              //
//           76 65 73           //
//        68 60 53 57 69        //
//     72 56 49 45 46 61 77     //
//     64 52 44 41 42 50 62     //
//     75 59 48 43 47 54 70     //
//        67 55 51 58 66        //
//           71 63 74           //
//                              //

int  EIDACTemplateX[EIDACTEMPLATESIZE] = {-1, 0,-1,+1, 0,-1, 0,-1,+1, 0,-1, 0,-1,+1, 0,-1, 0,-1,+1, 0,-1, 0,-1,+1, 0,-1, 0,-1,+1, 0,-1, 0,-1,+1, 0,-1, 0,-1,+1};
int  EIDACTemplateY[EIDACTEMPLATESIZE] = { 0,-1,-1,-1, 0, 0,-1,-1,-1, 0, 0,-1,-1,-1, 0, 0,-1,-1,-1, 0, 0,-1,-1,-1, 0, 0,-1,-1,-1, 0, 0,-1,-1,-1, 0, 0,-1,-1,-1};
int  EIDACTemplateZ[EIDACTEMPLATESIZE] = { 0, 0, 0, 0, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 7, 7, 7, 7, 7};


//  39 37 33 27 24 28 34 38 40  //
//  35 29 21 17 14 18 22 30 36  //
//  31 19 11  9  6 10 12 20 32  //
//  25 15  7  3  2  4  8 16 26  //
//  23 13  5  1  ?              //
//                              //


int DisplacementX[12] = { 0, 0, 1, 1, 1, 1, 0, 0,-1,-1,-1,-1};
int DisplacementY[12] = {-1,-1,-1, 0, 0, 1, 1, 1, 1, 0, 0,-1};

