/************************************************************************
**  Filename: SearchBasic.h
** 
**  Search with Dynamical Programmming 
**  
**  Alexander Kolesnikov
**
** Email:
**   koles@cs.joensuu.fi
**   kolesnikov@iae.nsk.su
**
**  Copyright (c) 2003  Alexander Kolesnikov 
**
*************************************************************************/


#ifndef SEARCHBASIC_H
#define SEARCHBASIC_H

#include <math.h>
#include <stdlib.h>

#include "HistoData.h"
#include "VectSTD.h"
#include "TableStructs.h"



int  SearchInCorridor( Bounds *pBnd, DTable  *pD2, NTable *pNodes);

int DP_MSE_PolarQ_1(DArray *pR, DArray *pPhi, int M, int nType, double *value);
int DP_MSE_PolarQ_2(DArray *pR, DArray *pPhi, int M, int nType, double *value);

int CalcBounds(Bounds *pB);

int CalcBoundsOne2OneForFullSearch(Bounds *pB);
int CalcBoundsOne2One(Bounds *pB);



//////////////////////////////////////////////

#endif /* SEARCHBASIC_H */
